<template>
  <div :class="[$style.transactionItemWrapper]">
    <div :class="[$style.categoryIconWrapper]">
      <img :src="icon" :alt="transaction.category.name" :class="[$style.categoryIcon]">
    </div>
    <span :class="[$style.categoryName]">{{ transaction.category.name }}</span>
    <span :class="[$style.date]">{{ date }}</span>
    <span :class="[$style.sum, transaction.category.type === 'spending' ? $style.red : $style.green]">{{ totalSum }}</span>
  </div>
</template>

<style module>
.transactionItemWrapper {
  max-width: 600px;
  margin: 10px;
  padding: 10px;
  border: 1px solid black;
  border-radius: 10px;
  box-shadow: 4px 4px 8px 0px rgba(34, 60, 80, 0.2);
  display: grid;
  grid-template-rows: 1fr 1fr;
  grid-template-columns: 60px 3fr 1fr;
  grid-template-areas:
    "categoryIcon categoryName sum"
    "categoryIcon date         sum";
}
.categoryIconWrapper {
  grid-area: categoryIcon;
  width: 48px;
  height: 48px;
  overflow: hidden;
  border-radius: 50%;
  justify-self: left;
  align-self: center;
}
.categoryIconWrapper .categoryIcon {
  width: 58px;
  height: auto;
  object-fit: cover;
  object-position: -5px -5px;
}
.categoryName {
  grid-area: categoryName;
}
.date {
  grid-area: date;
}
.sum {
  grid-area: sum;
  font-weight: bold;
  font-size: 1.1rem;
  justify-self: right;
  align-self: center;
}
.red {
  color: #ff6453;
}
.green {
  color: #2d995b;
}
</style>

<script>
import moment from 'moment';
export default {
  props: {
    transaction: {
      type: Object,
    },
  },
  data() {
    return {

    };
  },
  computed: {
    totalSum: function () {
      return `${this.transaction.category.currency_key} ${this.transaction.amount}`
    },
    date: function () {
      return moment(this.transaction.created_at).locale('ru').calendar({
        sameElse: 'L[, в] LT',
      });
    },
    icon: function () {
      return this.transaction.category.icon_path || '/img/answer.jpg';
    },
  },
};
</script>